package clock;

import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

public class TimeClock {

	long startTime = 0;

	long currentTime = 0;

	long timeout = 60;

	long diff = 0;

	boolean paused = false;

	SetTime field = null;

	UpdateTime updateTime = null;


	public TimeClock(SetTime field) {
		this.field = field;
		startTime = now();
	}

	public String getElapsedTime() {
		currentTime = now();
		return formatTime(currentTime - startTime);
	}

	public void setTimer(String timer) {
		// parse & set
	}

	private static String formatTime(long l) {
		String secs = pad(new Long(l % 60).toString());
		String mins = pad(new Long((l / 60) % 60).toString());
		String hours = pad(new Long((l / 3600) % 60).toString());
		String time = hours + ":" + mins + ":" + secs;
		return time;
	}

	protected static String pad(String s) {
		return (s.length() == 1 ? "0" + s : s);
	}


	public void start() {
		Timer timer = new Timer();
		updateTime = new UpdateTime();
		timer.schedule(updateTime, 0, 1000);
	}

	class UpdateTime extends TimerTask {
		String nextAlarm = null;

		public void run() {
			String elapsedTime = getElapsedTime();
			field.setTime(elapsedTime);
		}
	}


	public void stop() {
		updateTime.cancel();
		updateTime = null;
	}

	private long now() {
		return (new Date()).getTime() / 1000;
	}
}
