package timer;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.graphics.Font;

import clock.SetTime;
import clock.TimeClock;

public class CountupTimer implements SetTime {

	private Shell sShell = null; // @jve:decl-index=0:visual-constraint="10,10"

	private Label counterLabel = null;

	private Button startButton = null;

	private Button stopButton = null;

	private Label label = null;

	private Font font;

	private TimeClock clock = null;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		/*
		 * Before this is run, be sure to set up the launch configuration
		 * (Arguments->VM Arguments) for the correct SWT library path in order
		 * to run with the SWT dlls. The dlls are located in the SWT plugin jar.
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 * installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		CountupTimer thisClass = new CountupTimer();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData2 = new org.eclipse.swt.layout.GridData();
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		gridData2.heightHint = -1;
		gridData2.widthHint = 80;
		gridData2.horizontalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		GridData gridData1 = new org.eclipse.swt.layout.GridData();
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.verticalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		gridData1.widthHint = 80;
		gridData1.horizontalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		GridData gridData = new org.eclipse.swt.layout.GridData();
		gridData.horizontalSpan = 2;
		gridData.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
		gridData.verticalAlignment = org.eclipse.swt.layout.GridData.FILL;
		gridData.grabExcessVerticalSpace = true;
		gridData.grabExcessHorizontalSpace = true;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		sShell = new Shell();
		sShell.setText("Countup Timer");
		sShell.setLayout(gridLayout);
		sShell.setSize(new org.eclipse.swt.graphics.Point(297, 177));
		counterLabel = new Label(sShell, SWT.CENTER);
		counterLabel.setText("00:00:00");
		font = new Font(Display.getDefault(), "Tahoma", 24, SWT.NORMAL);
		counterLabel.setFont(font);
		counterLabel.setLayoutData(gridData);
		stopButton = new Button(sShell, SWT.NONE);
		stopButton.setText("Start");
		stopButton.setLayoutData(gridData1);
		stopButton
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(
							org.eclipse.swt.events.SelectionEvent e) {
						if(clock==null)
						{
						clock = new TimeClock(CountupTimer.this);
						clock.start();
						}
						else
						{
							Display.getDefault().beep();

						}
					}
				});
		startButton = new Button(sShell, SWT.NONE);
		startButton.setText("Stop");
		startButton.setLayoutData(gridData2);
		startButton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if(clock!=null)
				{
					clock.stop();
				}
				clock=null;
			}
		});
		label = new Label(sShell, SWT.NONE);
		label.addDisposeListener(new org.eclipse.swt.events.DisposeListener() {
			public void widgetDisposed(org.eclipse.swt.events.DisposeEvent e) {
				font.dispose();
			}
		});
	}

	public void setTime(final String time) {
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				counterLabel.setText(time);
			}
		});
	}
}
